Attribute VB_Name = "modMultiResolution"
Option Explicit

'
' Passt die Grsse des Formulars und der Steuerelemente den bergebenen Werten an.
'
Public Sub ShowSizedForm(ByVal Form As Form, ByVal NewWidth As Single, ByVal CenterForm As Boolean)
    Dim OldWidth As Single
    OldWidth = Form.Width
    
    ' Berechnen, um wieviel der Clientbereich niedriger/schmaler als die Hhe
    ' des gesamten Formulars ist.
    Dim DiffX As Single, DiffY As Single
    DiffY = Form.Height - Form.ScaleHeight
    DiffX = Form.Width - Form.ScaleWidth
    
    ' Verhltnis zwischen alten "Einheiten" und neuen "Einheiten" berechnen.
    Dim ScaleFactor As Single
    ScaleFactor = (NewWidth - DiffX) / (Form.Width - DiffX)
    
    Dim ClientHeight As Single
    ClientHeight = Form.Height - DiffY
    Form.Height = ClientHeight * ScaleFactor + DiffY
    Form.Width = NewWidth
    
    ' Fehler bei Timern etc unterdrcken.
    On Error Resume Next
    
    ' Alle Steuerelemente anpassen.
    Dim Control As Control
    For Each Control In Form.Controls
        
        ' DriveListBox und ComboBox untersttzen die 'Move'-Methode nicht.
        If TypeOf Control Is DriveListBox Or TypeOf Control Is ComboBox Then
            Control.Top = Control.Top * ScaleFactor
            Control.Left = Control.Left * ScaleFactor
            Control.Width = Control.Width * ScaleFactor
            Control.Height = Control.Height * ScaleFactor
        
        ' Das Line-Steuerelement wird anders positioniert.
        ElseIf TypeOf Control Is Line Then
            Control.X1 = Control.X1 * ScaleFactor
            Control.X2 = Control.X2 * ScaleFactor
            Control.Y1 = Control.Y1 * ScaleFactor
            Control.Y2 = Control.Y2 * ScaleFactor
            Control.BorderWidth = Control.BorderWidth * ScaleFactor
        
        ' Andere Steuerelemente (Label, TextBox etc.).
        Else
            Call Control.Move( _
                Control.Left * ScaleFactor, _
                Control.Top * ScaleFactor, _
                Control.Width * ScaleFactor, _
                Control.Height * ScaleFactor _
            )
            If TypeOf Control Is Shape Then
                Control.BorderWidth = Control.BorderWidth * ScaleFactor
            End If
        End If
        
        ' Schriftgrsse anpassen (Fehler, der bei Image-Steuerelement etc. entsteht, wird
        ' unterdrckt.
        Control.Font.Size = Control.Font.Size * ScaleFactor
        Call Control.Refresh
    Next Control
    
    ' Formular zentrieren.
    If CenterForm Then
        Call Form.Move((Screen.Width - Form.Width) * 0.5, (Screen.Height - Form.Height) * 0.5)
    End If
    Call Form.Show
End Sub
